# Folien

Diese Folien dienen für die Erklärung der GO-Regeln im Online-Anfängerkurs des Deutschen GO Bunds (DGOB).

Die Folien werden als reveal.js Präsentation und als PDF Datei bereitgestellt.

## Lizenz

Dieser Foliensatz wird unter Create Commons Attribution Share-Alike Non-Commercial 4.0 (CC-BY-SA-NC 4.0) weitergegeben. Die Lizenz kann in der [Lizenzdatei](LICENSE) eingesehen werden.

Ausnahme von der Lizenz: Das Logo des Deutschen Go Bund e.V. gehört zum DGOB e.V. und darf außerhalb des Deutschen Go Bund e.V. nicht eingesetzt werden. Die Weiterverwendung des Foliensatzes außerhalb des DGOB erfordert somit ein Entfernen des Logos aus dem Foliensatz.

## Mitmachen

Über einen regulären GIT Pull Request können Änderungen beantragt werden.

### Formatierung

Die Formatierung erfolgt im AsciiDoc Format. Die Konvertierung erfolgt mit AsciiDoctor-Reveal.js.

### Bilder

Ein Großteil der Bilder existieren als SGF Datei. Diese werden mittel [sgf-render](https://github.com/julianandrews/sgf-render/) in SVG konvertiert und anschließend beim Erzeugen der Folien zu PNG umgewandelt.

### Erzeugen der Folien

Die Folien werden über das Rakefile erzeugt. Hierfür bundler erzeugt. Mittels

```shell
$ bundle exec rake
...
```

erzeugt.

Die resultierenden Dateien liegen im Ordner `out`. Die Datei kann mit jedem Browser geöffnet werden. Über einen Browser-Druck kann die Datei schnell in eine PDF konvertiert werden, indem in PDF gedruckt wird.

### Starten der Präsentation

Die Präsentation kann über den `present` Befehl gestartet werden.

```shell
$ bundle exec rake present
...
```

Der Webbrowser öffnet sich und die Präsentation wird gestartet. Wenn über den lokalen Rechner Pop-Ups erlaubt sind, kann über Drücken der Taste `s` eine Ansicht für den Präsentator geöffnet werden.

### Abhängigkeiten

Nach dem Auschecken kann eigentlich auch direkt mittel `bundle exec rake present` die Präsentation gestartet werden. Sämtliche vorherigen Schritte werden ausgeführt.

## Entwicklungsumgebung

### Editor

Jeder Texteditor kann verwendet werden. Am nützlichsten hat sich Microsoft VisualStudio Code herausgestellt.

### Benötigte Programme

Benötigt werden eine [`ruby` Installation](https://www.ruby-lang.org/de/) (Mindestversion: 2.7) mit [bundler](https://bunder.io) (Mindestversion 2.1) und [yarn](https://yarnpkg.com/) (yarn 1.22).

#### Installation unter Windows

Am Besten nutzt man den [Chocolatey package manager](https://chocolatey.org/):

```shell
$ choco install -y ruby yarn
...
```

#### Installation unter Linux

Dies ist distributionsabhängig und kann über die entsprechenden Pakete installiert werden.

Unter Debian / Ubuntu / LinuxMint benötigt man nur für yarn folgende Paketquelle:

```apt
deb https://dl.yarnpkg.com/debian/ stable main
```

Danach kann über

```shell
$ apt update && apt install yarn bundler
...
```

die Software installiert werden.

#### Installation auf MAC OS X

Am Besten geht es über [Homebrew](https://brew.sh/). Dies geht dann über

```shell
$ brew install yarn ruby
...
```

### Wiederherstellen der Umgebung

Mittels `bundle install` und `bundle exec rake prepare` sollten alle notwendigen Pakete wiederhergestellt werden.
