require 'yaml'
require 'fileutils'

presentation_file = TARGET_FILE

namespace :build do
    task :out_dir do
        Dir.mkdir(TARGET_DIRECTORY) unless Dir.exists?(TARGET_DIRECTORY) 
    end

    task slides: presentation_file do |t|
    end

    task revealjs: [ "out_dir" ] do |t|
        target_dir = File.join(TARGET_DIRECTORY, REVEAL_JS_DIR)
        FileUtils.cp_r(REVEAL_DIR, target_dir)
    end

    file presentation_file => [ "out_dir", "revealjs" ] do |t|
        attributes = {}
        if File.exists? SETTINGS_FILE
            content = File.read SETTINGS_FILE
            yaml = YAML.load content
            attributes = yaml["reveal"]
            attributes.merge! yaml["meta"]
        end

        attributes_args = ""
        attributes.each do |k, v|
            attributes_args += " -a #{k}=\"#{v}\""
        end

        sh "asciidoctor-revealjs #{SOURCE_FILE} -o #{TARGET_FILE} #{attributes_args}"
    end
end
