require 'fileutils'
require 'pathname'

namespace :prepare do
    task yarn: [] do |t|
        sh 'yarn install' unless Dir.exists? NODE_MODULES_DIR
    end

    task reveal: [ "yarn", "reveal:fonts", "reveal:copy" ] do |t|
    end

    namespace :reveal do
        CSS_COMPILE = "css"
        CSS_TARGET = "css"
        PRINT_DIR = "print"
        THEME_DIR = "theme"
        JS_DIR = "js"
        PLUGIN_DIR = "plugin"

        reveal_css_dir = File.join(REVEAL_DIR, CSS_COMPILE)
        reveal_css_theme_dir = File.join(reveal_css_dir, THEME_DIR)
        reveal_css_print_dir = File.join(reveal_css_dir, PRINT_DIR)
        reveal_js_dir = File.join(REVEAL_DIR, JS_DIR)

        task :dir do
            Dir.mkdir(TOOLS_DIR) unless Dir.exists?(TOOLS_DIR)
            Dir.mkdir(REVEAL_DIR) unless Dir.exists?(REVEAL_DIR)
            Dir.mkdir(reveal_css_dir) unless Dir.exists?(reveal_css_dir)
            Dir.mkdir(reveal_css_theme_dir) unless Dir.exists?(reveal_css_theme_dir)
            Dir.mkdir(reveal_css_print_dir) unless Dir.exists?(reveal_css_print_dir)
            Dir.mkdir(reveal_js_dir) unless Dir.exists?(reveal_js_dir)
        end

        task js: [ "dir" ] do
            js_dir = File.join(".", NODE_MODULES_DIR, REVEAL_JS_DIR, "dist")
            target_reveal_js_dir = Pathname.new(reveal_js_dir).realpath
            Dir.chdir(js_dir) do
                Dir.glob("*.js") do |source_file|
                    js_target_file = File.join(target_reveal_js_dir, source_file)
                    FileUtils.cp(source_file, js_target_file)
                end
            end
        end

        task copy: [ "dir" ] do
            nm_source_dir = File.join(".", NODE_MODULES_DIR, REVEAL_JS_DIR)
            target_dir = TOOLS_DIR
            FileUtils.cp_r(nm_source_dir, target_dir)
        end

        task fonts: [ "dir", "copy" ] do
            fonts_dir = File.join(".", NODE_MODULES_DIR, REVEAL_JS_DIR, "lib", "font")
            target_fonts_dir = File.join(reveal_css_dir, THEME_DIR)
            FileUtils.cp_r(fonts_dir, target_fonts_dir)
        end
    end

end